#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         myName

 Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here
#include <file.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#Region ### START Koda GUI section ### Form=c:\users\greg\desktop\autoit\mtk cidr firewall\form1.kxf
$Form1_1 = GUICreate("GregSowell.com Convert CIDR To Firewall Mikrotik", 615, 469, 192, 124)
$edtRules = GUICtrlCreateEdit("", 8, 8, 593, 305)
;GUICtrlSetData(-1, "edtRules")
$Group1 = GUICtrlCreateGroup("Output Type", 8, 320, 209, 49)
$rdoFirewall = GUICtrlCreateRadio("Firewall Rules", 24, 342, 89, 17)
$rdoAddress = GUICtrlCreateRadio("Address List", 125, 342, 81, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$btnConvert = GUICtrlCreateButton("Convert", 232, 336, 81, 25)
$Label1 = GUICtrlCreateLabel("Address List Name/Firewall Rule Coment", 336, 320, 196, 17)
$inName = GUICtrlCreateInput("GregSowell", 336, 344, 193, 21)
$grpFirewall = GUICtrlCreateGroup("Allow or Block", 8, 376, 209, 81)
$rdoAllow = GUICtrlCreateRadio("Allow", 24, 398, 89, 17)
$rdoDeny = GUICtrlCreateRadio("Deny", 125, 398, 81, 17)
$chkInput = GUICtrlCreateCheckbox("Input", 24, 424, 81, 17)
$chkForward = GUICtrlCreateCheckbox("Forward", 125, 422, 81, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
;GUICtrlSetState($grpFirewall, $GUI_HIDE)
;GUICtrlSetState($, $GUI_HIDE)
;GUICtrlSetState($grpFirewall, $GUI_HIDE)
;GUICtrlSetState($grpFirewall, $GUI_HIDE)
;GUICtrlSetState($grpFirewall, $GUI_HIDE)
GUICtrlSetState($rdoAddress, $GUI_CHECKED)
GUICtrlSetState($rdoDeny, $GUI_CHECKED)
GUICtrlSetState($chkForward, $GUI_CHECKED)
GUICtrlSetState($chkInput, $GUI_CHECKED)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###



While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		;Case $rdo
		Case $btnConvert
			;convert code here.
			;MsgBox(0,0,GUICtrlRead($rdoAddress))
			FileDelete(@ScriptDir & "\temp.txt")
			$fileTemp = FileOpen(@ScriptDir & "\temp.txt", 1)

			; Check if file opened for writing OK
			If $fileTemp = -1 Then
    			MsgBox(0, "Error", "Unable to open file.")
    			Exit
			EndIf

			FileWriteLine($fileTemp, GUICtrlRead($edtRules))

			FileClose($fileTemp)


			Dim $aList
			If Not _FileReadToArray(@ScriptDir & "\temp.txt",$aList) Then
   			MsgBox(4096,"Error", " Error reading log to Array     error:" & @error)
   			Exit
			EndIf
			;For $x = 1 to $aList[0]
    		;	Msgbox(0,'Record:' & $x, $aList[$x])
			;Next


			if GUICtrlRead($rdoAddress) == 1 Then
				;address list style
				_ConvertAddress()
			Else
				;firewall rule style
				_ConvertFirewall()
			EndIf
			MsgBox(0,"Results Complete", "Your results have been coppied to the clipboard.  Paste these into notepad or your router.")

	EndSwitch
WEnd

Func _ConvertAddress()
	;
	$Results = "/ip firewall address-list" & @CRLF
	For $x = 1 to $aList[0]
  			;Msgbox(0,'Record:' & $x, $aList[$x])
		;MsgBox(0,StringInStr("1" & $aList[$x], "#"), $aList[$x])
		if StringInStr("1" & $aList[$x], "#") == 2 Then
			;comment
			;MsgBox(0,0,$aList[$x])
		Else
			;/ip firewall address-list
			;add address=209.189.228.144/28 disabled=no list=localSubnets

			$Results = $Results & "add address=" & $aList[$x] & " disabled=no list=" & GUICtrlRead($inName) & @CRLF
		EndIf
	Next
	$Results = $Results & "/ip firewall filter" & @CRLF
	if GUICtrlRead($chkForward) == 1 Then
		;
		if GUICtrlRead($rdoDeny) == 1 Then
			$Results = $Results & "add action=reject disabled=no chain=forward comment=""" & GUICtrlRead($inName) & " drop"" src-address-list=" & GUICtrlRead($inName) & @CRLF
		Else
			$Results = $Results & "add action=accept disabled=no chain=forward comment=""" & GUICtrlRead($inName) & " allow"" src-address-list=" & GUICtrlRead($inName) & @CRLF
		EndIf
	EndIf
	if GUICtrlRead($chkInput) == 1 Then
		;
		if GUICtrlRead($rdoDeny) == 1 Then
			$Results = $Results & "add action=reject disabled=no chain=input comment=""" & GUICtrlRead($inName) & " drop"" src-address-list=" & GUICtrlRead($inName) & @CRLF
		Else
			$Results = $Results & "add action=accept disabled=no chain=input comment=""" & GUICtrlRead($inName) & " allow"" src-address-list=" & GUICtrlRead($inName) & @CRLF
		EndIf
	EndIf
	clipput($Results)
	;MsgBox(0,0,GUICtrlRead($edtRules))

EndFunc

Func _ConvertFirewall()
	;/ip firewall filter
	$Results = "/ip firewall filter" & @CRLF
	if GUICtrlRead($chkForward) == 1 Then
		For $x = 1 to $aList[0]
				;Msgbox(0,'Record:' & $x, $aList[$x])
			;MsgBox(0,StringInStr("1" & $aList[$x], "#"), $aList[$x])
			if StringInStr("1" & $aList[$x], "#") == 2 Then
				;comment
				;MsgBox(0,0,$aList[$x])
			Else
				;add action=reject chain=forward comment="Use Regex and Address Lists to block some bots trying to hack webpages" disabled=no reject-with=icmp-admin-prohibited \
				;   src-address-list=HackAttempt
				;MsgBox(0,0,GUICtrlRead($chkForward))
				if GUICtrlRead($rdoDeny) == 1 Then
					$Results = $Results & "add action=reject disabled=no chain=forward comment=""" & GUICtrlRead($inName) & """ src-address=" & $aList[$x] & @CRLF
				Else
					$Results = $Results & "add action=accept disabled=no chain=forward comment=""" & GUICtrlRead($inName) & """ src-address=" & $aList[$x] & @CRLF
				EndIf
			EndIf
		Next
	EndIf
	if GUICtrlRead($chkInput) == 1 Then
		For $x = 1 to $aList[0]
				;Msgbox(0,'Record:' & $x, $aList[$x])
			;MsgBox(0,StringInStr("1" & $aList[$x], "#"), $aList[$x])
			if StringInStr("1" & $aList[$x], "#") == 2 Then
				;comment
				;MsgBox(0,0,$aList[$x])
			Else
				;add action=reject chain=forward comment="Use Regex and Address Lists to block some bots trying to hack webpages" disabled=no reject-with=icmp-admin-prohibited \
				;   src-address-list=HackAttempt
				;MsgBox(0,0,GUICtrlRead($chkForward))
				if GUICtrlRead($rdoDeny) == 1 Then
					$Results = $Results & "add action=reject disabled=no chain=input comment=""" & GUICtrlRead($inName) & """ src-address=" & $aList[$x] & @CRLF
				Else
					$Results = $Results & "add action=accept disabled=no chain=input comment=""" & GUICtrlRead($inName) & """ src-address=" & $aList[$x] & @CRLF
				EndIf
			EndIf
		Next
	EndIf
	clipput($Results)
EndFunc